#include "ahp.hpp"
#include "crt.hpp"

int WINAPI _export Start(const struct PluginStartupInfo *FarInfo,const struct AHPluginStartupInfo *AHInfo)
{
  (void *)FarInfo;
  (void *)AHInfo;
  return 0;
}

void WINAPI _export Exit(void)
{
}

int WINAPI _export Message(unsigned long Msg,void *InData,void *OutData)
{
  switch(Msg)
  {
    case AHMSG_GETINFO:
      {
        GetInfoOutData *data=(GetInfoOutData *)OutData;
        data->TypesNumber=1;
        static struct TypeInfo TypesInfo[1];
        memset(TypesInfo,0,sizeof(TypeInfo)/sizeof(TypesInfo[0]));
        TypesInfo[0].StructSize=sizeof(TypesInfo[0]);
        lstrcpy(TypesInfo[0].TypeString,"WinHelp");
        lstrcpy(TypesInfo[0].Mask,"*.hlp");
        lstrcpy(TypesInfo[0].Encoding,"WIN");
        data->TypesInfo=TypesInfo;
      }
      return TRUE;

    case AHMSG_SHOWHELP:
      {
        HelpInData *data = (HelpInData *)InData;
        UINT uiCommand;
        DWORD dwData;
        if (*data->Keyword)
        {
          uiCommand = HELP_KEY;
          dwData = (DWORD)data->Keyword;
        }
        else
        {
          uiCommand = HELP_FINDER;
          dwData = NULL;
        }
        return WinHelp(GetDesktopWindow(),data->FileName,uiCommand,dwData);
      }
  }
  return FALSE;
}
