#include <windows.h>
#include "registry.hpp"
#include <stdio.h>

#define MAX_ITEMS ('Z' - 'A' + 1)

extern char PluginRootKey[];
char PluginRootKey[1024];

int GetHelpInfo(char *fd, char *fn, char *fm, unsigned int *ff, char *fe, char *fk, char *ft, int i)
{
  char Value[50];
  sprintf(Value,"File%d",i);
  if (!GetRegKey(Value,fn,"",512))
    return FALSE;
  sprintf(Value,"Desc%d",i);
  if (!GetRegKey(Value,fd,"",512))
    return FALSE;
  sprintf(Value,"Mask%d",i);
  GetRegKey(Value,fm,"",512);
  sprintf(Value,"Flags%d",i);
  char tmp[10];
  GetRegKey(Value,tmp,"0",sizeof(tmp));
  sscanf(tmp,"%u",ff);
  sprintf(Value,"Type%d",i);
  GetRegKey(Value,ft,"",512);
  sprintf(Value,"Keyword%d",i);
  GetRegKey(Value,fk,"",512);
  sprintf(Value,"Encoding%d",i);
  GetRegKey(Value,fe,"AUTO",128);
  return TRUE;
}

void SetHelpInfo(char *fd, char *ft, char *fn, char *fk, char *fm, char *fe, char *ff, int i)
{
  char Value[50];
  sprintf(Value,"Desc%d",i);
  SetRegKey(Value,fd);
  sprintf(Value,"Type%d",i);
  SetRegKey(Value,ft);
  sprintf(Value,"File%d",i);
  SetRegKey(Value,fn);
  sprintf(Value,"Keyword%d",i);
  SetRegKey(Value,fk);
  sprintf(Value,"Mask%d",i);
  SetRegKey(Value,fm);
  sprintf(Value,"Flags%d",i);
  SetRegKey(Value,ff);
  sprintf(Value,"Encoding%d",i);
  SetRegKey(Value,fe);
}

int main()
{
  printf("This program will convert help file settings of Active-Help\n");
  printf("version prior to 2.1 to version 2.1 format.\n");
  printf("This program should not be run more than once!\n");
  printf("Are you sure you want to continue? [y/n]: ");
  char ch;
  scanf("%c",&ch);
  if (ch!='y')
  {
    printf("Aborting!\n");
    exit(1);
  }
  printf("Converting");
  char user[512];
  lstrcpy(PluginRootKey,"Software\\Far\\");
  if (GetEnvironmentVariable("FARUSER",user,sizeof(user)))
  {
    lstrcat(PluginRootKey,"Users\\");
    lstrcat(PluginRootKey,user);
    lstrcat(PluginRootKey,"\\");
  }
  lstrcat(PluginRootKey,"Plugins\\Active-Help");
  char fd[512], ft[512], fn[512], fk[512], fm[512], fe[128], ff[20];
  unsigned int ffi;
  char *fnp;

  for (int i=0; i<MAX_ITEMS; i++)
  {
    printf(".");
    if (!GetHelpInfo(fd,fn,fm,&ffi,fe,fk,ft,i))
      break;
    fnp=fn;
    if (strstr(fn,"://"))
    {
      lstrcpyn(ft,fn,strstr(fn,"://")-fn+1);
      fnp=strstr(fn,"://")+3;
    }
    if (strstr(fnp,"|"))
    {
      lstrcpy(fk,strstr(fnp,"|")+1);
      *strstr(fnp,"|")=0;
    }
    ff[0]=(ffi&1)+'0';
    ff[1]=(ffi&2)+'0';
    ff[2]=0;
    SetHelpInfo(fd,ft,fnp,fk,fm,fe,ff,i);
  }
  printf("Done\n");
  return 0;
}
